{$R+}
unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, ExtCtrls, StdCtrls, Grids, Buttons, ValEdit,
  Controls, Spin, ComCtrls, Classes, Serial, DateUtils, Forms, Registry,
  Dialogs, Clipbrd, Graphics, IniFiles;

const
  SERIAL_ERROR = Ord('-');
  SERIAL_ACK = Ord('+');

const
  srRead = $00;
  srWrite = $10;

  srRTC = $00;
  srEEPROM = $20;
  srState = $40;

  pgConst = 0;
  pgEkvith = 1;
  pgWall = 2;
  pgModeA = 3;
  pgModeB = 6;
  pgModeC = 9;
  pgLogFirst = 12;
  pgLogLast = 15; 

  serialAdVal = 0;
  serialUpVal = 1;
  serialActVal = 2;
  serialInfo = 3;
  serialVer = 4;
  serialDebug = 5;

  addrShift = $0;
  addrMode = $1;
  addrThstat = $2;
  addrSwMode = $3;
  addrSwDays = $4;
  addrSwHours = $5;
  addrPLog = $6;
  addrRunCount = $7;

  addrSrvTime = $10;
  addrEkvMul = $11;
  addrThstatMul = $12;
  addrHysteresis = $13;
  addrPumpMintemp = $14;
  addrPumpMaxtime = $15;
  addrEkvDelay = $16;
  addrThstatDelay = $17;
  addrWaterbackMin = $18;
  addrWallMax = $19;
  addrEkvithMax = $1A;
  addrThstatMax = $1B;
  addrThstatSens = $1C;
  addrWallMul = $1D;

  addrCorrections = $20;
  addrUseSensors = $28;
  addrLogFirst = $29;

  addrSensorsText = $80; 

type
  TMainForm = class(TForm)
    PageControl: TPageControl;
    tsClockSensors: TTabSheet;
    tiClock: TTimer;
    GroupBox1: TGroupBox;
    edClockReg: TEdit;
    GroupBox2: TGroupBox;
    edClockPC: TEdit;
    GroupBox3: TGroupBox;
    edClockHandHour: TEdit;
    edClockHandMin: TEdit;
    edClockHandSec: TEdit;
    cbClockHandDay: TComboBox;
    Label3: TLabel;
    Label4: TLabel;
    sbClockUpdateByPC: TSpeedButton;
    sbClockUpdateByHand: TSpeedButton;
    sbClockUpdateHandByPC: TSpeedButton;
    tsEkvith: TTabSheet;
    tsMode: TTabSheet;
    tsConst: TTabSheet;
    GroupBox5: TGroupBox;
    GroupBox6: TGroupBox;
    GroupBox7: TGroupBox;
    seSrvTime: TSpinEdit;
    sePumpMinTemp: TSpinEdit;
    sePumpMaxTime: TSpinEdit;
    Label2: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label9: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    seEkvMul: TSpinEdit;
    seEkvDelay: TSpinEdit;
    seWallMax: TSpinEdit;
    seEkvithMax: TSpinEdit;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    seThstatMul: TSpinEdit;
    seThstatDelay: TSpinEdit;
    seThstatMax: TSpinEdit;
    Label28: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    seThstat: TSpinEdit;
    Label33: TLabel;
    Label34: TLabel;
    seShift: TSpinEdit;
    Label35: TLabel;
    GroupBox8: TGroupBox;
    Label36: TLabel;
    cbSens0Used: TCheckBox;
    cbSens1Used: TCheckBox;
    cbSens2Used: TCheckBox;
    cbSens3Used: TCheckBox;
    cbSens4Used: TCheckBox;
    cbSens5Used: TCheckBox;
    cbSens6Used: TCheckBox;
    cbSens7Used: TCheckBox;
    seSens0Corr: TSpinEdit;
    seSens1Corr: TSpinEdit;
    seSens2Corr: TSpinEdit;
    seSens3Corr: TSpinEdit;
    seSens4Corr: TSpinEdit;
    seSens5Corr: TSpinEdit;
    seSens6Corr: TSpinEdit;
    seSens7Corr: TSpinEdit;
    Label29: TLabel;
    Label8: TLabel;
    seWaterbackMin: TSpinEdit;
    Label13: TLabel;
    Panel1: TPanel;
    btReset: TButton;
    btRead: TButton;
    btWrite: TButton;
    Label5: TLabel;
    seHysteresis: TSpinEdit;
    Label10: TLabel;
    Label14: TLabel;
    seWallMul: TSpinEdit;
    Label15: TLabel;
    Label37: TLabel;
    cbMode: TComboBox;
    GroupBox9: TGroupBox;
    Label38: TLabel;
    cbSwMode: TComboBox;
    Label39: TLabel;
    seSwDays: TSpinEdit;
    Label40: TLabel;
    GroupBox10: TGroupBox;
    Label41: TLabel;
    Label42: TLabel;
    Label43: TLabel;
    cbThstatSens: TComboBox;
    cbLog1: TComboBox;
    cbLog2: TComboBox;
    cbLog3: TComboBox;
    cbLog4: TComboBox;
    dgMode: TDrawGrid;
    vlEkvith: TValueListEditor;
    imEkvithGraph: TImage;
    GroupBox11: TGroupBox;
    leEkvithFillA: TLabeledEdit;
    leEkvithFillB: TLabeledEdit;
    leEkvithFillC: TLabeledEdit;
    btFillEkvith: TButton;
    lbModeCaption: TLabel;
    lbMode: TLabel;
    lbTempDeltaCaption: TLabel;
    lbTempDelta: TLabel;
    lbTauCaption: TLabel;
    lbTau: TLabel;
    lbWallCaption: TLabel;
    lbWall: TLabel;
    GroupBox12: TGroupBox;
    paDigitUser: TPanel;
    paBlrOn: TPanel;
    paESW: TPanel;
    paSrvO: TPanel;
    paSrvC: TPanel;
    paPump: TPanel;
    paBlr: TPanel;
    Label50: TLabel;
    Label52: TLabel;
    Label55: TLabel;
    Label56: TLabel;
    Label57: TLabel;
    Label58: TLabel;
    Label59: TLabel;
    Label60: TLabel;
    Label61: TLabel;
    Label62: TLabel;
    GroupBox13: TGroupBox;
    lbSens0Name: TLabel;
    lbSens1Name: TLabel;
    lbSens2name: TLabel;
    lbSens3Name: TLabel;
    lbSens4Name: TLabel;
    lbSens5Name: TLabel;
    lbSens6Name: TLabel;
    lbSens7Name: TLabel;
    lbSensor0: TLabel;
    lbSensor1: TLabel;
    lbSensor2: TLabel;
    lbSensor3: TLabel;
    lbSensor4: TLabel;
    lbSensor5: TLabel;
    lbSensor6: TLabel;
    lbSensor7: TLabel;
    cbSensorsQuick: TCheckBox;
    lbParamCaption: TLabel;
    lbParam: TLabel;
    tsWall: TTabSheet;
    vlWall: TValueListEditor;
    GroupBox14: TGroupBox;
    Label71: TLabel;
    Label75: TLabel;
    Label76: TLabel;
    seWallDepth: TSpinEdit;
    Label77: TLabel;
    seWallTemp: TSpinEdit;
    Label78: TLabel;
    seWallSensDepth: TSpinEdit;
    Label79: TLabel;
    btFillWall: TButton;
    cbComPort: TComboBox;
    btInfo: TButton;
    GroupBox4: TGroupBox;
    rbModeA: TRadioButton;
    rbModeB: TRadioButton;
    rbModeC: TRadioButton;
    btLoad: TButton;
    btSave: TButton;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    seSwHours: TSpinEdit;
    Label1: TLabel;
    edSens0Name: TEdit;
    Label44: TLabel;
    edSens1Name: TEdit;
    edSens2Name: TEdit;
    edSens3Name: TEdit;
    edSens4Name: TEdit;
    edSens5Name: TEdit;
    edSens6Name: TEdit;
    edSens7Name: TEdit;
    GroupBox16: TGroupBox;
    Label45: TLabel;
    edRunCount: TEdit;
    SpeedButton1: TSpeedButton;
    Label46: TLabel;
    lbWallMul: TLabel;
    Label47: TLabel;
    edEkvithFillB: TEdit;
    tsLogs: TTabSheet;
    sgLogs: TStringGrid;
    btLogsCopy: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure cbComPortChange(Sender: TObject);
    procedure tiClockTimer(Sender: TObject);
    procedure PageControlChange(Sender: TObject);
    procedure sbClockUpdateByPCClick(Sender: TObject);
    procedure sbClockUpdateHandByPCClick(Sender: TObject);
    procedure sbClockUpdateByHandClick(Sender: TObject);
    procedure btResetClick(Sender: TObject);
    procedure tsLogsShow(Sender: TObject);
    procedure btLogsCopyClick(Sender: TObject);
    procedure btReadClick(Sender: TObject);
    procedure btWriteClick(Sender: TObject);
    procedure dgModeDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure dgModeGetEditText(Sender: TObject; ACol, ARow: Integer;
      var Value: String);
    procedure dgModeSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure dgModeMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btFillEkvithClick(Sender: TObject);
    procedure vlEkvithStringsChange(Sender: TObject);
    procedure btFillWallClick(Sender: TObject);
    procedure btInfoClick(Sender: TObject);
    procedure dgHexEditorSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure dgHexEditorGetEditText(Sender: TObject; ACol, ARow: Integer;
      var Value: String);
    procedure btLoadClick(Sender: TObject);
    procedure btSaveClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    FMode: array[1..7, 1..96] of Byte;
    FHexEditorData: array[0..255] of Byte;
    FSavedMinute: Byte;
    function DoComm(const Request; var Response; ReqLength, ResLength: Word): Boolean;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

procedure TMainForm.FormCreate(Sender: TObject);
begin
  with TRegistry.Create do begin
    RootKey := HKEY_LOCAL_MACHINE;
    OpenKey('Software\EMIR', True);
    leEkvithFillA.Text := FloatToStr(StrToFloatDef(ReadString('EkvithFillA'), 0));
    leEkvithFillB.Text := FloatToStr(StrToFloatDef(ReadString('EkvithFillB'), -0.7));
    edEkvithFillB.Text := FloatToStr(StrToFloatDef(ReadString('EkvithFillB'), -0.7));
    leEkvithFillC.Text := FloatToStr(StrToFloatDef(ReadString('EkvithFillC'), 51));
    seWallDepth.Value := StrToIntDef(ReadString('WallDepth'), 45);
    seWallSensDepth.Value := StrToIntDef(ReadString('WallSensDepth'), 17);
    seWallTemp.Value := StrToIntDef(ReadString('WallTemp'), 21);
    cbComPort.ItemIndex := StrToIntDef(ReadString('ComPort'), 0);
    Free;
  end;
  cbComPortChange(Sender);
  vlEkvithStringsChange(Sender);
  PageControlChange(Sender);
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  CloseCom;
  with TRegistry.Create do begin
    RootKey := HKEY_LOCAL_MACHINE;
    OpenKey('Software\EMIR', True);
    WriteString('EkvithFillA', leEkvithFillA.Text);
    WriteString('EkvithFillB', leEkvithFillB.Text);
    WriteString('EkvithFillC', leEkvithFillC.Text);
    WriteString('WallDepth', seWallDepth.Text);
    WriteString('WallSensDepth', seWallSensDepth.Text);
    WriteString('WallTemp', seWallTemp.Text);
    WriteString('ComPort', IntToStr(cbComPort.ItemIndex));
    Free;
  end;
end;

procedure TMainForm.cbComPortChange(Sender: TObject);
begin
  CloseCom;
  if not OpenCom(cbComPort.Text, 9600) then begin
    Application.MessageBox(PChar('Nelze otevt port ' + cbComPort.Text), 'Regulace', MB_OK or MB_ICONERROR);
  end;
end;

function TMainForm.DoComm(const Request; var Response; ReqLength, ResLength: Word): Boolean;
var
  OldCursor: TCursor;
begin
  OldCursor := Screen.Cursor;
  if ResLength > 10 then Screen.Cursor := crHourGlass;
  FlushInputCom;
  if (not WriteCom(Request, ReqLength)) or (not ReadCom(Response, ResLength)) then begin
    Screen.Cursor := OldCursor;
    tiClock.Enabled := False;
    Application.MessageBox('Chyba komunikace', 'Regulace', MB_OK or MB_ICONERROR);
    Result := False;
  end else begin
    Screen.Cursor := OldCursor;
    Result := True;
  end;
end;

function ConvertWZero(W: Word): string;
begin
  Result := IntToStr(W);
  if Length(Result) < 2 then Result := '0' + Result;
end;

procedure TMainForm.tiClockTimer(Sender: TObject);
const
  DaysCz: array[0..7] of string =
    ('pondl', 'ter', 'steda', 'tvrtek', 'ptek', 'sobota', 'nedle', '(chyba)');
  Modes: array[0..3] of string =
    ('vypnuto', 'ekvitermn', 'termostat', '(chyba)');
var
  Request: Byte;
  TimeResponse: array[1..4] of Byte;
  SensorsResponse: array[1..3] of array[0..7] of Byte;
  InfoResponse: array[1..6] of Byte;
begin
  Request := srRTC or srRead;
  if not DoComm(Request, TimeResponse, 1, 4) then Exit;

  if not (TimeResponse[4] in [0..6]) then TimeResponse[4] := 7;

  edClockReg.Text := ConvertWZero(TimeResponse[3]) + ':' +
                     ConvertWZero(TimeResponse[2]) + ':' +
                     ConvertWZero(TimeResponse[1]) + ', ' +
                     DaysCz[TimeResponse[4]];
  edClockPC.Text := FormatDateTime('hh:nn:ss, dddd', Now);

  Request := srState or srRead or serialInfo;
  if not DoComm(Request, InfoResponse, 1, 6) then Exit;
  if InfoResponse[1] and 64 = 0 then paDigitUser.Color := $7F7FFF
                                else paDigitUser.Color := $7FFF7F;
  if InfoResponse[1] and 32 = 0 then paBlrOn.Color := $7F7FFF
                                else paBlrOn.Color := $7FFF7F;
  if InfoResponse[1] and 16 = 0 then paESW.Color := $7F7FFF
                                else paESW.Color := $7FFF7F;
  if InfoResponse[1] and 8  = 0 then paSrvO.Color := $7F7FFF
                                else paSrvO.Color := $7FFF7F;
  if InfoResponse[1] and 4  = 0 then paSrvC.Color := $7F7FFF
                                else paSrvC.Color := $7FFF7F;
  if InfoResponse[1] and 2  = 0 then paPump.Color := $7F7FFF
                                else paPump.Color := $7FFF7F;
  if InfoResponse[1] and 1  = 0 then paBlr.Color := $7F7FFF
                                else paBlr.Color := $7FFF7F;

  if cbSensorsQuick.Checked then begin
    FSavedMinute := 255;

    Request := srState or srRead or serialAdVal;
    if not DoComm(Request, SensorsResponse[1], 1, 8) then Exit;
    Request := srState or srRead or serialActVal;
    if not DoComm(Request, SensorsResponse[3], 1, 8) then Exit;

    lbSensor0.Caption := Format('akt. %d C, AD %d', [SensorsResponse[3][7], SensorsResponse[1][7]]);
    lbSensor1.Caption := Format('akt. %d C, AD %d', [SensorsResponse[3][6], SensorsResponse[1][6]]);
    lbSensor2.Caption := Format('akt. %d C, AD %d', [SensorsResponse[3][5], SensorsResponse[1][5]]);
    lbSensor3.Caption := Format('akt. %d C, AD %d', [SensorsResponse[3][4], SensorsResponse[1][4]]);
    lbSensor4.Caption := Format('akt. %d C, AD %d', [SensorsResponse[3][3], SensorsResponse[1][3]]);
    lbSensor5.Caption := Format('akt. %d C, AD %d', [SensorsResponse[3][2], SensorsResponse[1][2]]);
    lbSensor6.Caption := Format('akt. %d C, AD %d', [SensorsResponse[3][1], SensorsResponse[1][1]]);
    lbSensor7.Caption := Format('akt. %d C, AD %d', [SensorsResponse[3][0], SensorsResponse[1][0]]);

  end else if TimeResponse[2] <> FSavedMinute then begin // kazkou minutu
    FSavedMinute := TimeResponse[2];

    if not (InfoResponse[2] in [0..2]) then InfoResponse[2] := 3;
    lbMode.Caption := Modes[InfoResponse[2]];
    case InfoResponse[2] of
      1:   begin {ekv}
             lbParamCaption.Visible := True; lbParam.Visible := True;
             lbParamCaption.Caption := 'Posun:';
             lbParam.Caption := IntToStr(ShortInt(InfoResponse[4])) + ' C';
             if lbParam.Caption[1] <> '-' then lbParam.Caption := '+' + lbParam.Caption;
             lbTempDeltaCaption.Visible := True; lbTempDelta.Visible := True;
             lbTempDelta.Caption := IntToStr(ShortInt(InfoResponse[5])) + ' C';
             if lbTempDelta.Caption[1] <> '-' then lbTempDelta.Caption := '+' + lbTempDelta.Caption;
             lbTauCaption.Visible := True; lbTau.Visible := True;
             lbTau.Caption := IntToStr(ShortInt(InfoResponse[3])) + ' sec';
             if lbTau.Caption[1] <> '-' then lbTau.Caption := '+' + lbTau.Caption;
             lbWallCaption.Visible := True; lbWall.Visible := True;
             lbWall.Caption := IntToStr(ShortInt(InfoResponse[6])) + ' C';
             if lbWall.Caption[1] <> '-' then lbWall.Caption := '+' + lbWall.Caption;
           end;

      2:   begin {ter}
             lbParamCaption.Visible := True; lbParam.Visible := True;
             lbParamCaption.Caption := 'Termostat:';
             lbParam.Caption := IntToStr(InfoResponse[4]) + ' C';
             lbTempDeltaCaption.Visible := True; lbTempDelta.Visible := True;
             lbTempDelta.Caption := IntToStr(ShortInt(InfoResponse[5])) + ' C';
             if lbTempDelta.Caption[1] <> '-' then lbTempDelta.Caption := '+' + lbTempDelta.Caption;
             lbTauCaption.Visible := True; lbTau.Visible := True;
             lbTau.Caption := IntToStr(ShortInt(InfoResponse[3])) + ' sec';
             if lbTau.Caption[1] <> '-' then lbTau.Caption := '+' + lbTau.Caption;
             lbWallCaption.Visible := False; lbWall.Visible := False;
           end;

      else begin {vyp,err}
             lbParamCaption.Visible := False; lbParam.Visible := False;
             lbTempDeltaCaption.Visible := False; lbTempDelta.Visible := False;
             lbTauCaption.Visible := False; lbTau.Visible := False;
             lbWallCaption.Visible := False; lbWall.Visible := False;
           end;
    end;

    Request := srState or srRead or serialUpVal;
    if not DoComm(Request, SensorsResponse[2], 1, 8) then Exit;

    lbSensor0.Caption := Format('%d C', [SensorsResponse[2][7]]);
    lbSensor1.Caption := Format('%d C', [SensorsResponse[2][6]]);
    lbSensor2.Caption := Format('%d C', [SensorsResponse[2][5]]);
    lbSensor3.Caption := Format('%d C', [SensorsResponse[2][4]]);
    lbSensor4.Caption := Format('%d C', [SensorsResponse[2][3]]);
    lbSensor5.Caption := Format('%d C', [SensorsResponse[2][2]]);
    lbSensor6.Caption := Format('%d C', [SensorsResponse[2][1]]);
    lbSensor7.Caption := Format('%d C', [SensorsResponse[2][0]]);
  end;
end;

procedure TMainForm.PageControlChange(Sender: TObject);
var
  Request: Byte;
  EepromResponse: array[0..255] of Byte;
  I, J: Integer;
  S: string;
begin
  tiClock.Enabled := False;
  FSavedMinute := 255;
  if PageControl.ActivePage.Name = 'tsClockSensors' then begin
    btRead.Enabled := False;
    btWrite.Enabled := False;
    btLoad.Enabled := False;
    btSave.Enabled := False;
    tiClock.Enabled := True;
    Application.ProcessMessages;

    Request := srEeprom or srRead or pgConst;
    if not DoComm(Request, EepromResponse, 1, 256) then Exit;
    for I := 0 to 7 do begin
      J := 0; S := '';
      while (J < 16) and not (EepromResponse[addrSensorsText+I*16+J] in [0, 255]) do begin
        S := S + Char(EepromResponse[addrSensorsText+I*16+J]);
        Inc(J);
      end;
      TLabel(FindComponent(Format('lbSens%dName', [I]))).Caption := S;
    end;

    tiClockTimer(Sender);
  end else if PageControl.ActivePage.Name = 'tsLogs' then begin
    btRead.Enabled := True;
    btWrite.Enabled := False;
    btLoad.Enabled := False;
    btSave.Enabled := True;
    SaveDialog.Filter := 'Soubory formtu CSV (*.csv)|*.csv|Vechny soubory (*.*)|*.*';
    SaveDialog.DefaultExt := 'csv';
  end else begin
    btRead.Enabled := True;
    btWrite.Enabled := True;
    btLoad.Enabled := True;
    btSave.Enabled := True;
    OpenDialog.Filter := 'Soubory konfigurace (*.emr)|*.emr|Vechny soubory (*.*)|*.*';
    SaveDialog.Filter := 'Soubory konfigurace (*.emr)|*.emr|Vechny soubory (*.*)|*.*';
    SaveDialog.DefaultExt := 'emr';
  end;
end;

procedure TMainForm.sbClockUpdateByPCClick(Sender: TObject);
var
  Request: Byte;
  Response: Byte;
begin
  Request := srRTC or srWrite;
  if not DoComm(Request, Response, 1, 1) then Exit;
  Request := SecondOf(Now);
  if not DoComm(Request, Response, 1, 1) then Exit;
  Request := MinuteOf(Now);
  if not DoComm(Request, Response, 1, 1) then Exit;
  Request := HourOf(Now);
  if not DoComm(Request, Response, 1, 1) then Exit;
  Request := DayOfTheWeek(Now) - 1;
  if not DoComm(Request, Response, 1, 0) then Exit;
end;

procedure TMainForm.sbClockUpdateHandByPCClick(Sender: TObject);
begin
  edClockHandHour.Text := ConvertWZero(HourOf(Now));
  edClockHandMin.Text := ConvertWZero(MinuteOf(Now));
  edClockHandSec.Text := ConvertWZero(SecondOf(Now));
  cbClockHandDay.ItemIndex := DayOfTheWeek(Now) - 1;
end;

procedure TMainForm.sbClockUpdateByHandClick(Sender: TObject);
var
  Request: Byte;
  Response: Byte;
begin
  Request := srRTC or srWrite;
  if not DoComm(Request, Response, 1, 1) then Exit;
  Request := StrToInt(edClockHandSec.Text);
  if not DoComm(Request, Response, 1, 1) then Exit;
  Request := StrToInt(edClockHandMin.Text);
  if not DoComm(Request, Response, 1, 1) then Exit;
  Request := StrToInt(edClockHandHour.Text);
  if not DoComm(Request, Response, 1, 1) then Exit;
  Request := cbClockHandDay.ItemIndex;
  if not DoComm(Request, Response, 1, 0) then Exit;
end;

procedure TMainForm.btResetClick(Sender: TObject);
var
  Request, Dummy: Byte;
begin
  if Application.MessageBox('Opravdu resetovat?', 'Regulace', MB_YESNO or MB_ICONQUESTION) <> IDYES then Exit;
  Request := srState or srWrite;
  if not DoComm(Request, Dummy, 1, 0) then Exit;
end;

procedure TMainForm.tsLogsShow(Sender: TObject);
const
  DaysCz: array[1..7] of string = ('Po', 't', 'St', 't', 'P', 'So', 'Ne');
var
  I: Integer;
  DT: Int64;
begin
  with sgLogs do begin
    Cells[0, 0] := 'Datum';
    DT := DateTimeToUnix(Now);
    for I := 256 downto 1 do begin
      Cells[0, I] := DaysCz[DayOfTheWeek(UnixToDateTime(DT))] + ' ' +
                     IntToStr(HourOf(UnixToDateTime(DT))) + ':00';
      DT := DT - 3600;
    end;
  end;
end;

procedure TMainForm.btLogsCopyClick(Sender: TObject);
var
  S: WideString;
  I, J: Integer;
begin
  S := '';
  for I := sgLogs.Selection.Top to sgLogs.Selection.Bottom do begin
    S := S + sgLogs.Cells[0, I] + #9;
    for J := 1 to 4 do S := S + Copy(sgLogs.Cells[J, I], 1, Length(sgLogs.Cells[J, I]) - 3) + #9;
    S[Length(S)] := #13;
    S := S + #10;
  end;
  Clipboard.AsText := S;
end;

procedure TMainForm.btReadClick(Sender: TObject);
const
  DaysCz: array[1..7] of string =
    ('Po', 't', 'St', 't', 'P', 'So', 'Ne');
  SensorNames: array[0..8] of string =
    ('Vst. voda', 'Vrat. voda', 'Uiv. 1', 'Vnitn',
     'Venkovn', 'Ze', 'Uiv. 2', 'Uiv. 3', '(chyba)');
var
  Request: Byte;
  EepromResponse: array[0..255] of Byte;
  ModeResponse: array[0..256*3-1] of Byte;
  AList: TStringList;
  StartPos: Byte;
  I, J: Integer;
  DT: Int64;
  S: string;
begin
  if PageControl.ActivePage.Name = 'tsConst' then begin
    Request := srEeprom or srRead or pgConst;
    if not DoComm(Request, EepromResponse, 1, 256) then Exit;

    seEkvMul.Value := EepromResponse[addrEkvMul];
    seEkvDelay.Value := EepromResponse[addrEkvDelay];
    seEkvithMax.Value := EepromResponse[addrEkvithMax];
    seShift.Value := ShortInt(EepromResponse[addrShift]);
    seHysteresis.Value := EepromResponse[addrHysteresis];
    seWallMax.Value := EepromResponse[addrWallMax];
    seWallMul.Value := EepromResponse[addrWallMul];

    seThstatMul.Value := EepromResponse[addrThstatMul];
    seThstatDelay.Value := EepromResponse[addrThstatDelay];
    seThstatMax.Value := EepromResponse[addrThstatMax];
    seThstat.Value := EepromResponse[addrThstat];
    cbThstatSens.ItemIndex := EepromResponse[addrThstatSens];

    cbMode.ItemIndex := EepromResponse[addrMode];
    seSrvTime.Value := EepromResponse[addrSrvTime];
    sePumpMinTemp.Value := EepromResponse[addrPumpMintemp];
    sePumpMaxTime.Value := EepromResponse[addrPumpMaxtime];
    seWaterbackMin.Value := EepromResponse[addrWaterbackMin];

    cbSwMode.ItemIndex := EepromResponse[addrSwMode];
    seSwDays.Value := EepromResponse[addrSwDays];
    seSwHours.Value := EepromResponse[addrSwHours];

    for I := 0 to 7 do begin
      TCheckBox(FindComponent(Format('cbSens%dUsed', [I]))).Checked := (EepromResponse[addrUseSensors] and (1 shl I)) <> 0;
      TSpinEdit(FindComponent(Format('seSens%dCorr', [I]))).Value := ShortInt(EepromResponse[addrCorrections + I]);
      J := 0; S := '';
      while (J < 16) and not (EepromResponse[addrSensorsText+I*16+J] in [0, 255]) do begin
        S := S + Char(EepromResponse[addrSensorsText+I*16+J]);
        Inc(J);
      end;
      TEdit(FindComponent(Format('edSens%dName', [I]))).Text := S;
    end;

    cbLog1.ItemIndex := EepromResponse[addrLogFirst + 0];
    cbLog2.ItemIndex := EepromResponse[addrLogFirst + 1];
    cbLog3.ItemIndex := EepromResponse[addrLogFirst + 2];
    cbLog4.ItemIndex := EepromResponse[addrLogFirst + 3];

    edRunCount.Text := IntToStr(EepromResponse[addrRunCount]);

  end else if PageControl.ActivePage.Name = 'tsMode' then begin

    if rbModeA.Checked then
      Request := srEeprom or srRead or pgModeA
    else if rbModeB.Checked then
      Request := srEeprom or srRead or pgModeB
    else
      Request := srEeprom or srRead or pgModeC;
    if not DoComm(Request, ModeResponse[0], 1, 256) then Exit;
    Inc(Request);
    if not DoComm(Request, ModeResponse[256], 1, 256) then Exit;
    Inc(Request);
    if not DoComm(Request, ModeResponse[512], 1, 256) then Exit;

    for I := 0 to (4*24)*7-1 do
      FMode[I div (4*24) + 1, I mod (4*24) + 1] := ModeResponse[I];

    dgMode.Refresh;

  end else if PageControl.ActivePage.Name = 'tsEkvith' then begin

    Request := srEEPROM or srRead or pgEkvith;
    if not DoComm(Request, EepromResponse, 1, 256) then Exit;

    AList := TStringList.Create;
    try
      for I := -40 to 25 do AList.Add(Format('%d C=%d', [I, EepromResponse[I + 128]]));
      vlEkvith.Strings.Assign(AList);
    finally
      AList.Free;
    end;

  end else if PageControl.ActivePage.Name = 'tsWall' then begin

    Request := srEEPROM or srRead or pgWall;
    if not DoComm(Request, EepromResponse, 1, 256) then Exit;

    AList := TStringList.Create;
    try
      for I := -40 to 25 do AList.Add(Format('%d C=%d', [I, ShortInt(EepromResponse[I + 128])]));
      vlWall.Strings.Assign(AList);
    finally
      AList.Free;
    end;

  end else if PageControl.ActivePage.Name = 'tsLogs' then begin

    DT := DateTimeToUnix(Now);
    for I := 256 downto 1 do begin
      sgLogs.Cells[0, I] := DaysCz[DayOfTheWeek(UnixToDateTime(DT))] + ' ' +
                            IntToStr(HourOf(UnixToDateTime(DT))) + ':00';
      DT := DT - 3600;
    end;
    Request := srEeprom or srRead or pgConst;
    if not DoComm(Request, EepromResponse, 1, 256) then Exit;
    StartPos := (EepromResponse[addrPLog] + 1) mod 256;
    if not (EepromResponse[addrLogFirst + 0] in [0..7]) then EepromResponse[addrLogFirst + 0] := 8;
    sgLogs.Cells[1, 0] := SensorNames[EepromResponse[addrLogFirst + 0]];
    if not (EepromResponse[addrLogFirst + 1] in [0..7]) then EepromResponse[addrLogFirst + 1] := 8;
    sgLogs.Cells[2, 0] := SensorNames[EepromResponse[addrLogFirst + 1]];
    if not (EepromResponse[addrLogFirst + 2] in [0..7]) then EepromResponse[addrLogFirst + 2] := 8;
    sgLogs.Cells[3, 0] := SensorNames[EepromResponse[addrLogFirst + 2]];
    if not (EepromResponse[addrLogFirst + 3] in [0..7]) then EepromResponse[addrLogFirst + 3] := 8;
    sgLogs.Cells[4, 0] := SensorNames[EepromResponse[addrLogFirst + 3]];
    for I := 1 to 4 do begin
      Request := srEeprom or srRead or (pgLogFirst - 1 + I);
      if not DoComm(Request, EepromResponse, 1, 256) then Exit;
      for J := 0 to 255 do
        sgLogs.Cells[I, J + 1] := IntToStr(ShortInt(EepromResponse[((J + StartPos) mod 256)])) + ' C';
    end;
    sgLogs.TopRow := sgLogs.RowCount - sgLogs.VisibleRowCount;
  end;
end;

procedure TMainForm.btWriteClick(Sender: TObject);
var
  Request, WrData: Byte;
  Response: Byte;
  EepromData: array[0..255] of Byte;
  ModeData: array[0..256*3-1] of Byte;
  I, J: Integer;
  Page: Byte;
  S: string;

  function WriteEeprom(Page: Byte; const Data): Boolean;
  type
    TArray = array[0..255] of Byte;
  var
    I: Integer;
  begin
    Result := False;

    Request := srEEPROM or srWrite or (Page and 15);
    if not DoComm(Request, Response, 1, 1) then Exit;

    Screen.Cursor := crHourGlass;
    for I := 0 to 255 do begin
      WrData := TArray(Data)[I];
      if I <> 255 then begin
        if not DoComm(WrData, Response, 1, 1) then Break;
      end else begin
        if not DoComm(WrData, Response, 1, 0) then Break;
        Result := True;
      end;
    end;
    Screen.Cursor := crDefault;
  end;

begin
  if Application.MessageBox('Opravdu zapsat?', 'Regulace', MB_YESNO or MB_ICONQUESTION) <> IDYES then Exit;

  if PageControl.ActivePage.Name = 'tsConst' then begin
    Request := srEeprom or srRead or pgConst;
    if not DoComm(Request, EepromData, 1, 256) then Exit;

    EepromData[addrEkvMul] := seEkvMul.Value;
    EepromData[addrEkvDelay] := seEkvDelay.Value;
    EepromData[addrEkvithMax] := seEkvithMax.Value;
    EepromData[addrShift] := Byte(seShift.Value);
    EepromData[addrHysteresis] := seHysteresis.Value;
    EepromData[addrWallMax] := seWallMax.Value;
    EepromData[addrWallMul] := seWallMul.Value;

    EepromData[addrThstatMul] := seThstatMul.Value;
    EepromData[addrThstatDelay] := seThstatDelay.Value;
    EepromData[addrThstatMax] := seThstatMax.Value;
    EepromData[addrThstat] := seThstat.Value;
    EepromData[addrThstatSens] := cbThstatSens.ItemIndex;

    EepromData[addrMode] := cbMode.ItemIndex;
    EepromData[addrSrvTime] := seSrvTime.Value;
    EepromData[addrPumpMintemp] := sePumpMinTemp.Value;
    EepromData[addrPumpMaxtime] := sePumpMaxTime.Value;
    EepromData[addrWaterbackMin] := seWaterbackMin.Value;

    EepromData[addrSwMode] := cbSwMode.ItemIndex;
    EepromData[addrSwDays] := seSwDays.Value;
    EepromData[addrSwHours] := seSwHours.Value;

    EepromData[addrUseSensors] := 0;
    for I := 0 to 7 do begin
      if TCheckBox(FindComponent(Format('cbSens%dUsed', [I]))).Checked then Inc(EepromData[addrUseSensors], (1 shl I));
      EepromData[addrCorrections + I] := Byte(TSpinEdit(FindComponent(Format('seSens%dCorr', [I]))).Value);
      S := TEdit(FindComponent(Format('edSens%dName', [I]))).Text;
      for J := 0 to Length(S) - 1 do EepromData[addrSensorsText+I*16+J] := Byte(S[J+1]);
      EepromData[addrSensorsText+I*16+Length(S)] := 0;
    end;

    EepromData[addrLogFirst + 0] := cbLog1.ItemIndex;
    EepromData[addrLogFirst + 1] := cbLog2.ItemIndex;
    EepromData[addrLogFirst + 2] := cbLog3.ItemIndex;
    EepromData[addrLogFirst + 3] := cbLog4.ItemIndex;

    EepromData[addrRunCount] := StrToIntDef(edRunCount.Text, 0);

    WriteEeprom(pgConst, EepromData);

  end else if PageControl.ActivePage.Name = 'tsMode' then begin

    FillChar(ModeData, SizeOf(ModeData), #0);

    for I := 1 to 7 do
      for J := 1 to 96 do
        ModeData[(I - 1) * 96 + (J - 1)] := FMode[I, J];

    if rbModeA.Checked then Page := pgModeA
    else if rbModeB.Checked then Page := PgModeB
    else Page := pgModeC;

    Move(ModeData[0*256], EepromData, 256);
    if not WriteEeprom(Page+0, EepromData) then Exit;

    Move(ModeData[1*256], EepromData, 256);
    if not WriteEeprom(Page+1, EepromData) then Exit;

    Move(ModeData[2*256], EepromData, 256);
    WriteEeprom(Page+2, EepromData);

  end else if PageControl.ActivePage.Name = 'tsEkvith' then begin

    with vlEkvith do begin
      for I := -128 to -41 do EepromData[I + 128] := StrToIntDef(Copy(Strings[0], Pos('=', Strings[0]) + 1, 255), 20);
      for I := -40 to 25 do EepromData[I + 128] := StrToIntDef(Copy(Strings[I + 40], Pos('=', Strings[I + 40]) + 1, 255), 20);
      for I := 26 to 127 do EepromData[I + 128] := StrToIntDef(Copy(Strings[65], Pos('=', Strings[65]) + 1, 255), 20);
    end;
    WriteEeprom(pgEkvith, EepromData);

  end else if PageControl.ActivePage.Name = 'tsWall' then begin

    with vlWall do begin
      for I := -128 to -41 do EepromData[I + 128] := Byte(StrToIntDef(Copy(Strings[0], Pos('=', Strings[0]) + 1, 255), 20));
      for I := -40 to 25 do EepromData[I + 128] := Byte(StrToIntDef(Copy(Strings[I + 40], Pos('=', Strings[I + 40]) + 1, 255), 20));
      for I := 26 to 127 do EepromData[I + 128] := Byte(StrToIntDef(Copy(Strings[65], Pos('=', Strings[65]) + 1, 255), 20));
    end;
    WriteEeprom(pgWall, EepromData);

  end;
end;

procedure TMainForm.dgModeDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var
  S: string;
  AMode: Byte;
  AValue: Byte;
begin
  if gdFixed in State then begin
    if ARow = 0 then begin
      case ACol of
        1: S := 'Pondl';
        2: S := ' ter';
        3: S := 'Steda';
        4: S := 'tvrtek';
        5: S := ' Ptek';
        6: S := 'Sobota';
        7: S := 'Nedle';
        else S := '';
      end;
      dgMode.Canvas.TextRect(Rect, Rect.Left+16, Rect.Top+2, S);
    end;
    if (ACol = 0) and (ARow in [1..96]) then begin
      S := Format('%d:%d', [(ARow - 1) div 4, (ARow - 1) mod 4 * 15]);
      if S[Length(S) - 1] = ':' then S := S + '0';
      S := S + ' hod';
      dgMode.Canvas.TextRect(Rect, Rect.Left+8, Rect.Top+2, S);
    end;
  end else begin
    AMode := FMode[ACol, ARow] and $C0 shr 6;
    AValue := FMode[ACol, ARow] and $3F;
    case AMode of
      0: begin {vyp}
           dgMode.Canvas.Brush.Color := $7FFF7F;
           dgMode.Canvas.FillRect(Rect);
           dgMode.Canvas.Font.Style := [fsBold];
           dgMode.Canvas.TextRect(Rect, Rect.Left+5, Rect.Top+2, 'V');
           dgMode.Canvas.Font.Style := [];
           S := 'Vypnuto';
         end;
      1: begin {ekv}
           dgMode.Canvas.Brush.Color := $7FFFFF;
           dgMode.Canvas.FillRect(Rect);
           dgMode.Canvas.Font.Style := [fsBold];
           dgMode.Canvas.TextRect(Rect, Rect.Left+5, Rect.Top+2, 'E');
           dgMode.Canvas.Font.Style := [];
           if (AValue and $20) = 0 then
             S := '+' + IntToStr(AValue)
           else
             S := IntToStr(AValue - $40);
         end;
      2: begin {ter}
           dgMode.Canvas.Brush.Color := $FFFF7F;
           dgMode.Canvas.FillRect(Rect);
           dgMode.Canvas.Font.Style := [fsBold];
           dgMode.Canvas.TextRect(Rect, Rect.Left+5, Rect.Top+2, 'T');
           dgMode.Canvas.Font.Style := [];
           S := IntToStr(AValue) + ' C';
         end;
    end;
    Rect.Left := Rect.Left + 20;
    dgMode.Canvas.TextRect(Rect, Rect.Left+2, Rect.Top+2, S);
  end;
end;

procedure TMainForm.dgModeGetEditText(Sender: TObject; ACol, ARow: Integer;
  var Value: String);
var
  AMode, AValue: Byte;
begin
  AMode := FMode[ACol, ARow] and $C0 shr 6;
  AValue := FMode[ACol, ARow] and $3F;
  case AMode of
    1: if (AValue and $20) = 0 then
         Value := '+' + IntToStr(AValue)
       else
         Value := '-' + IntToStr(AValue - $40);
    2: Value := IntToStr(AValue);
  end;
end;

procedure TMainForm.dgModeSetEditText(Sender: TObject; ACol, ARow: Integer;
  const Value: String);
var
  AMode, AValue: Byte;
  TmpVal: Integer;
begin
  AMode := FMode[ACol, ARow] and $C0 shr 6;
  TmpVal := StrToIntDef(Value, 0);
  AValue := 0;
  case AMode of
    1: begin
         if TmpVal > 31 then TmpVal := 31;
         if TmpVal < -32 then TmpVal := -32;
         AValue := TmpVal and $3F;
       end;
    2: begin
         if TmpVal > 63 then TmpVal := 63;
         if TmpVal < 0 then TmpVal := 0;
         AValue := TmpVal and $3F;
       end;
  end;
  FMode[ACol, ARow] := (AMode shl 6) or AValue;
end;

procedure TMainForm.dgModeMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  ACol, ARow: Longint;
  AMode: Byte;
begin
  if Button = mbRight then begin
    dgMode.MouseToCell(X, Y, ACol, ARow);
    AMode := FMode[ACol, ARow] and $C0 shr 6;
    AMode := AMode + 1;
    if AMode > 2 then AMode := 0;
    FMode[ACol, ARow] := (AMode shl 6) or (FMode[ACol, ARow] and $3F);
    dgModeDrawCell(Sender, ACol, ARow, dgMode.CellRect(ACol, ARow), []);
  end;
end;

procedure TMainForm.btFillEkvithClick(Sender: TObject);
var
  AList: TStringList;
  I: Integer;
begin
  AList := TStringList.Create;
  try
    for I := -40 to 25 do AList.Add(Format('%d C=%d', [I, Round(I*I*StrToFloatDef(leEkvithFillA.Text, 0) + I*StrToFloatDef(leEkvithFillB.Text, 0) + StrToFloatDef(leEkvithFillC.Text, 0))]));
    vlEkvith.Strings.Assign(AList);
  finally
    AList.Free;
  end;
end;

procedure TMainForm.vlEkvithStringsChange(Sender: TObject);
const
  ZoomX = 6;
  ZoomY = 3;
  RangeX = 65;
  RangeY = 80;
  StepX = 5;
  StepY = 10;
  SpaceX = 30;
  SpaceY = 40;
  CaptionX = 'Venkovn teplota [C]';
  CaptionY = 'Topn voda [C]';
var
  MirrY, Value: Integer;
  I: Integer;
begin
  with imEkvithGraph.Canvas, vlEkvith do begin
    MirrY := imEkvithGraph.Height;
    FillRect(imEkvithGraph.Canvas.ClipRect);

    Pen.Style := psDot;
    Pen.Color := clGray;
    for I := 0 to RangeX div StepX do begin
      TextOut(SpaceX+I*StepX*ZoomX-8, MirrY-(SpaceY-5), Format('%3d', [I * StepX - 40]));
      MoveTo(SpaceX+I*StepX*ZoomX, MirrY-(SpaceY));
      LineTo(SpaceX+I*StepX*ZoomX, MirrY-(SpaceY+RangeY*ZoomY+10));
    end;
    for I := 0 to RangeY div StepY do begin
      TextOut(SpaceX-24, MirrY-(SpaceY+I*StepY*ZoomY+6), Format('%3d', [I * StepY + 20]));
      MoveTo(SpaceX, MirrY-(SpaceY+I*StepY*ZoomY));
      LineTo(SpaceX+RangeX*ZoomX+10, MirrY-(SpaceY+I*StepY*ZoomY));
    end;
    Pen.Style := psSolid;
    Pen.Color := clBlack;

    MoveTo(SpaceX, MirrY-(SpaceY-1));
    LineTo(SpaceX+RangeX*ZoomX+20, MirrY-(SpaceY-1));

    MoveTo(SpaceX-1, MirrY-(SpaceY));
    LineTo(SpaceX-1, MirrY-(SpaceY+RangeY*ZoomY+20));

    TextOut(SpaceX+RangeX*ZoomX-70, MirrY-(SpaceY-20), CaptionX);
    TextOut(SpaceX-25, MirrY-(SpaceY+RangeY*ZoomY+35), CaptionY);

    for I := 0 to 65 do begin
      Value := StrToIntDef(Copy(Strings[I], Pos('=', Strings[I]) + 1, 255), 20) - 20;
      if Value > 80 then Value := 80;
      if Value < 0 then Value := 0;
      if I = 0 then
        MoveTo(SpaceX+I*ZoomX, MirrY-(SpaceY+Value*ZoomY))
      else
        LineTo(SpaceX+I*ZoomX, MirrY-(SpaceY+Value*ZoomY));
    end;
  end;
end;

procedure TMainForm.btFillWallClick(Sender: TObject);
var
  AList: TStringList;
  I: Integer;
begin
  AList := TStringList.Create;
  try
    for I := -40 to 25 do AList.Add(Format('%d C=%d', [I, Round(StrToFloatDef(seWallTemp.Text, 0) - (StrToFloatDef(seWallTemp.Text, 0) - I) * (StrToFloatDef(seWallSensDepth.Text, 0) / StrToFloatDef(seWallDepth.Text, 1)))]));
    vlWall.Strings.Assign(AList);
  finally
    AList.Free;
  end;
  lbWallMul.Caption := FloatToStrF(-(StrToFloatDef(seWallDepth.Text, 1) / StrToFloatDef(seWallSensDepth.Text, 1)) * StrToFloatDef(edEkvithFillB.Text, 1) * 4, ffFixed, 0, 2) + ' krt / 4';
end;

procedure TMainForm.btInfoClick(Sender: TObject);
var
  Request: Byte;
  Response: array[0..16] of Char;
begin
  Request := srState or srRead or serialVer;
  if not DoComm(Request, Response, 1, 16) then Exit;
  Response[16] := #0;
  Application.MessageBox(Response, 'Regulace', MB_OK or MB_ICONINFORMATION);
end;

procedure TMainForm.dgHexEditorSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
var
  UpVal: string;
  NewVal: Byte;
begin
  if Length(Value) <> 2 then Exit;
  UpVal := UpperCase(Value);
  if UpVal[2] in ['0'..'9'] then
    NewVal := Ord(UpVal[2]) - Ord('0')
  else if UpVal[2] in ['A'..'F'] then
    NewVal := Ord(UpVal[2]) - Ord('A') + 10
  else Exit;
  if UpVal[1] in ['0'..'9'] then
    NewVal := NewVal + (Ord(UpVal[1]) - Ord('0')) shl 4
  else if UpVal[1] in ['A'..'F'] then
    NewVal := NewVal + (Ord(UpVal[1]) - Ord('A') + 10) shl 4
  else Exit;
  FHexEditorData[ARow * 16 + (ACol - 1)] := NewVal;
end;

procedure TMainForm.dgHexEditorGetEditText(Sender: TObject; ACol,
  ARow: Integer; var Value: String);
begin
  Value := IntToHex(FHexEditorData[ARow * 16 + (ACol - 1)], 2);
end;

procedure TMainForm.btLoadClick(Sender: TObject);
var
  AList: TStringList;
  I: Integer;
  RdStream: TMemoryStream;
  Section: string;
begin
  if PageControl.ActivePage.Name = 'tsConst' then begin

    if not OpenDialog.Execute then Exit;
    with TIniFile.Create(OpenDialog.FileName) do begin
      seEkvMul.Value := ReadInteger('Const', 'EkvMul', 0);
      seEkvDelay.Value := ReadInteger('Const', 'EkvDelay', 0);
      seEkvithMax.Value := ReadInteger('Const', 'EkvithMax', 0);
      seShift.Value := ReadInteger('Const', 'Shift', 0);
      seHysteresis.Value := ReadInteger('Const', 'Hysteresis', 0);
      seWallMul.Value := ReadInteger('Const', 'WallMul', 0);
      seWallMax.Value := ReadInteger('Const', 'WallMax', 0);

      seThstatMul.Value := ReadInteger('Const', 'ThstatMul', 0);
      seThstatDelay.Value := ReadInteger('Const', 'ThstatDelay', 0);
      seThstatMax.Value := ReadInteger('Const', 'ThstatMax', 0);
      seThstat.Value := ReadInteger('Const', 'Thstat', 0);
      cbThstatSens.ItemIndex := ReadInteger('Const', 'ThstatSens', 0);

      cbMode.ItemIndex := ReadInteger('Const', 'Mode', 0);
      seSrvTime.Value := ReadInteger('Const', 'SrvTime', 0);
      sePumpMinTemp.Value := ReadInteger('Const', 'PumpMinTemp', 0);
      sePumpMaxTime.Value := ReadInteger('Const', 'PumpMaxTime', 0);
      seWaterbackMin.Value := ReadInteger('Const', 'WaterbackMin', 0);

      cbSwMode.ItemIndex := ReadInteger('Const', 'SwMode', 0);
      seSwDays.Value := ReadInteger('Const', 'SwDays', 0);
      seSwHours.Value := ReadInteger('Const', 'SwHours', 0);

      cbLog1.ItemIndex := ReadInteger('Const', 'Log1', 0);
      cbLog2.ItemIndex := ReadInteger('Const', 'Log2', 0);
      cbLog3.ItemIndex := ReadInteger('Const', 'Log3', 0);
      cbLog4.ItemIndex := ReadInteger('Const', 'Log4', 0);

      cbSens0Used.Checked := ReadBool('Const', 'Sens0Used', False);
      cbSens1Used.Checked := ReadBool('Const', 'Sens1Used', False);
      cbSens2Used.Checked := ReadBool('Const', 'Sens2Used', False);
      cbSens3Used.Checked := ReadBool('Const', 'Sens3Used', False);
      cbSens4Used.Checked := ReadBool('Const', 'Sens4Used', False);
      cbSens5Used.Checked := ReadBool('Const', 'Sens5Used', False);
      cbSens6Used.Checked := ReadBool('Const', 'Sens6Used', False);
      cbSens7Used.Checked := ReadBool('Const', 'Sens7Used', False);

      edSens0Name.Text := ReadString('Const', 'Sens0Name', '');
      edSens1Name.Text := ReadString('Const', 'Sens1Name', '');
      edSens2Name.Text := ReadString('Const', 'Sens2Name', '');
      edSens3Name.Text := ReadString('Const', 'Sens3Name', '');
      edSens4Name.Text := ReadString('Const', 'Sens4Name', '');
      edSens5Name.Text := ReadString('Const', 'Sens5Name', '');
      edSens6Name.Text := ReadString('Const', 'Sens6Name', '');
      edSens7Name.Text := ReadString('Const', 'Sens7Name', '');

      seSens0Corr.Value := ReadInteger('Const', 'Sens0Corr', 0);
      seSens1Corr.Value := ReadInteger('Const', 'Sens1Corr', 0);
      seSens2Corr.Value := ReadInteger('Const', 'Sens2Corr', 0);
      seSens3Corr.Value := ReadInteger('Const', 'Sens3Corr', 0);
      seSens4Corr.Value := ReadInteger('Const', 'Sens4Corr', 0);
      seSens5Corr.Value := ReadInteger('Const', 'Sens5Corr', 0);
      seSens6Corr.Value := ReadInteger('Const', 'Sens6Corr', 0);
      seSens7Corr.Value := ReadInteger('Const', 'Sens7Corr', 0);

      Free;
    end;

  end else if PageControl.ActivePage.Name = 'tsMode' then begin

    if not OpenDialog.Execute then Exit;
    with TIniFile.Create(OpenDialog.FileName) do begin
      if rbModeA.Checked then Section := 'ModeA'
      else if rbModeB.Checked then Section := 'ModeB'
      else Section := 'ModeC';
      RdStream := TMemoryStream.Create;
      ReadBinaryStream(Section, 'Data', RdStream);
      if RdStream.Size <> SizeOf(FMode) then Exit;
      Move(RdStream.Memory^, FMode, SizeOf(FMode));
      RdStream.Free;  
      dgMode.Refresh;
      Free;
    end;

  end else if PageControl.ActivePage.Name = 'tsEkvith' then begin

    if not OpenDialog.Execute then Exit;
    AList := TStringList.Create;
    with TIniFile.Create(OpenDialog.FileName) do begin
      for I := -40 to 25 do AList.Add(Format('%d C=%d', [I, ReadInteger('Ekvith', 'Ekvith' + IntToStr(I), 0)]));
      leEkvithFillA.Text := ReadString('Ekvith', 'EkvithFillA', '0');
      leEkvithFillB.Text := ReadString('Ekvith', 'EkvithFillB', '0');
      leEkvithFillC.Text := ReadString('Ekvith', 'EkvithFillC', '0');
      Free;
    end;
    vlEkvith.Strings.Assign(AList);
    AList.Free;

  end else if PageControl.ActivePage.Name = 'tsWall' then begin

    if not OpenDialog.Execute then Exit;
    AList := TStringList.Create;
    with TIniFile.Create(OpenDialog.FileName) do begin
      for I := -40 to 25 do AList.Add(Format('%d C=%d', [I, ReadInteger('Wall', 'Wall' + IntToStr(I), 0)]));
      seWallDepth.Value := ReadInteger('Wall', 'WallDepth', 0);
      seWallTemp.Value := ReadInteger('Wall', 'WallTemp', 0);
      seWallSensDepth.Value := ReadInteger('Wall', 'WallSensDepth', 0);
      edEkvithFillB.Text := ReadString('Wall', 'EkvithFillB', '0');
      Free;
    end;
    vlWall.Strings.Assign(AList);
    AList.Free;

  end;
end;

procedure TMainForm.btSaveClick(Sender: TObject);
var
  I, J: Integer;
  S, Section: string;
  WrStream: TMemoryStream;
begin
  if PageControl.ActivePage.Name = 'tsConst' then begin

    if not SaveDialog.Execute then Exit;
    with TIniFile.Create(SaveDialog.FileName) do begin

      WriteInteger('Const', 'EkvMul', seEkvMul.Value);
      WriteInteger('Const', 'EkvDelay', seEkvDelay.Value);
      WriteInteger('Const', 'EkvithMax', seEkvithMax.Value);
      WriteInteger('Const', 'Shift', seShift.Value);
      WriteInteger('Const', 'Hysteresis', seHysteresis.Value);
      WriteInteger('Const', 'WallMul', seWallMul.Value);
      WriteInteger('Const', 'WallMax', seWallMax.Value);

      WriteInteger('Const', 'ThstatMul', seThstatMul.Value);
      WriteInteger('Const', 'ThstatDelay', seThstatDelay.Value);
      WriteInteger('Const', 'ThstatMax', seThstatMax.Value);
      WriteInteger('Const', 'Thstat', seThstat.Value);
      WriteInteger('Const', 'ThstatSens', cbThstatSens.ItemIndex);

      WriteInteger('Const', 'Mode', cbMode.ItemIndex);
      WriteInteger('Const', 'SrvTime', seSrvTime.Value);
      WriteInteger('Const', 'PumpMinTemp', sePumpMinTemp.Value);
      WriteInteger('Const', 'PumpMaxTime', sePumpMaxTime.Value);
      WriteInteger('Const', 'WaterbackMin', seWaterbackMin.Value);

      WriteInteger('Const', 'SwMode', cbSwMode.ItemIndex);
      WriteInteger('Const', 'SwDays', seSwDays.Value);
      WriteInteger('Const', 'SwHours', seSwHours.Value);

      WriteInteger('Const', 'Log1', cbLog1.ItemIndex);
      WriteInteger('Const', 'Log2', cbLog2.ItemIndex);
      WriteInteger('Const', 'Log3', cbLog3.ItemIndex);
      WriteInteger('Const', 'Log4', cbLog4.ItemIndex);

      WriteBool('Const', 'Sens0Used', cbSens0Used.Checked);
      WriteBool('Const', 'Sens1Used', cbSens1Used.Checked);
      WriteBool('Const', 'Sens2Used', cbSens2Used.Checked);
      WriteBool('Const', 'Sens3Used', cbSens3Used.Checked);
      WriteBool('Const', 'Sens4Used', cbSens4Used.Checked);
      WriteBool('Const', 'Sens5Used', cbSens5Used.Checked);
      WriteBool('Const', 'Sens6Used', cbSens6Used.Checked);
      WriteBool('Const', 'Sens7Used', cbSens7Used.Checked);

      WriteString('Const', 'Sens0Name', edSens0Name.Text);
      WriteString('Const', 'Sens1Name', edSens1Name.Text);
      WriteString('Const', 'Sens2Name', edSens2Name.Text);
      WriteString('Const', 'Sens3Name', edSens3Name.Text);
      WriteString('Const', 'Sens4Name', edSens4Name.Text);
      WriteString('Const', 'Sens5Name', edSens5Name.Text);
      WriteString('Const', 'Sens6Name', edSens6Name.Text);
      WriteString('Const', 'Sens7Name', edSens7Name.Text);

      WriteInteger('Const', 'Sens0Corr', seSens0Corr.Value);
      WriteInteger('Const', 'Sens1Corr', seSens1Corr.Value);
      WriteInteger('Const', 'Sens2Corr', seSens2Corr.Value);
      WriteInteger('Const', 'Sens3Corr', seSens3Corr.Value);
      WriteInteger('Const', 'Sens4Corr', seSens4Corr.Value);
      WriteInteger('Const', 'Sens5Corr', seSens5Corr.Value);
      WriteInteger('Const', 'Sens6Corr', seSens6Corr.Value);
      WriteInteger('Const', 'Sens7Corr', seSens7Corr.Value);

      Free;
    end;

  end else if PageControl.ActivePage.Name = 'tsMode' then begin

    if not SaveDialog.Execute then Exit;
    with TIniFile.Create(SaveDialog.FileName) do begin
      if rbModeA.Checked then Section := 'ModeA'
      else if rbModeB.Checked then Section := 'ModeB'
      else Section := 'ModeC';
      WrStream := TMemoryStream.Create;
      WrStream.Write(FMode, SizeOf(FMode));
      WrStream.Seek(0, soFromBeginning);
      WriteBinaryStream(Section, 'Data', WrStream);
      WrStream.Free;
      Free;
    end;

  end else if PageControl.ActivePage.Name = 'tsEkvith' then begin

    if not SaveDialog.Execute then Exit;
    with TIniFile.Create(SaveDialog.FileName) do begin
      for I := -40 to 25 do WriteInteger('Ekvith', 'Ekvith' + IntToStr(I), StrToIntDef(Copy(vlEkvith.Strings[I + 40], Pos('=', vlEkvith.Strings[I + 40]) + 1, 255), 20));
      WriteString('Ekvith', 'EkvithFillA', leEkvithFillA.Text);
      WriteString('Ekvith', 'EkvithFillB', leEkvithFillB.Text);
      WriteString('Ekvith', 'EkvithFillC', leEkvithFillC.Text);
      Free;
    end;

  end else if PageControl.ActivePage.Name = 'tsLogs' then begin

    if not SaveDialog.Execute then Exit;
    with TFileStream.Create(SaveDialog.FileName, fmCreate) do begin
      for I := 0 to sgLogs.RowCount - 1 do begin
        S := '';
        for J := 0 to sgLogs.ColCount - 1 do S := S + sgLogs.Cells[J, I] + ';';
        Delete(S, Length(S), 1);
        S := S + #13#10;
        Write(S[1], Length(S) - 1);
      end;
      Free;
    end;

  end else if PageControl.ActivePage.Name = 'tsWall' then begin

    if not SaveDialog.Execute then Exit;
    with TIniFile.Create(SaveDialog.FileName) do begin
      for I := -40 to 25 do WriteInteger('Wall', 'Wall' + IntToStr(I), StrToIntDef(Copy(vlWall.Strings[I + 40], Pos('=', vlWall.Strings[I + 40]) + 1, 255), 20));
      WriteInteger('Wall', 'WallDepth', seWallDepth.Value);
      WriteInteger('Wall', 'WallTemp', seWallTemp.Value);
      WriteInteger('Wall', 'WallSensDepth', seWallSensDepth.Value);
      WriteString('Wall', 'EkvithFillB', edEkvithFillB.Text);
      Free;
    end;

  end;
end;

procedure TMainForm.SpeedButton1Click(Sender: TObject);
begin
  edRunCount.Text := '0';
end;

end.
